diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index f2df220d8..4b89587b4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
@@ -14,15 +14,16 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicLever extends BlockLogic implements ISupportable
-{
+public class BlockLogicLever extends BlockLogic implements ISupportable {
     public static final int MASK_POWERED = 0b0001_0000;
     public static final int MASK_ROTATION = 0b0000_1111;
     public static final int ROTATION_EAST = 1;
@@ -34,43 +35,39 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
     public static final int ROTATION_BOTTOM_NS = 7;
     public static final int ROTATION_BOTTOM_WE = 8;
 
-	public BlockLogicLever(@NotNull Block<?> block)
-    {
-        super(block, Material.decoration);
+    public BlockLogicLever(@NotNull Block<?> block) {
+        super(block, Materials.DECORATION);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         Side checkSide = side.getOpposite();
         return isSupported(world, tilePos, checkSide);
     }
 
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return isSupported(world, tilePos, Side.BOTTOM)
             || isSupported(world, tilePos, Side.TOP)
             || isSupported(world, tilePos, Side.NORTH)
@@ -78,47 +75,46 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
             || isSupported(world, tilePos, Side.WEST)
             || isSupported(world, tilePos, Side.EAST);
     }
-    
+
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
-        switch (side){
+        switch (side) {
             case BOTTOM:
-                if (isSupported(world, tilePos, Side.TOP)){
+                if (isSupported(world, tilePos, Side.TOP)) {
                     rotation = ROTATION_BOTTOM_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case TOP:
-                if (isSupported(world, tilePos, Side.BOTTOM))
-                {
+                if (isSupported(world, tilePos, Side.BOTTOM)) {
                     rotation = ROTATION_TOP_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case NORTH:
-                if (isSupported(world, tilePos, Side.SOUTH)){
+                if (isSupported(world, tilePos, Side.SOUTH)) {
                     rotation = ROTATION_NORTH;
                 }
                 break;
             case SOUTH:
-                if (isSupported(world, tilePos, Side.NORTH)){
+                if (isSupported(world, tilePos, Side.NORTH)) {
                     rotation = ROTATION_SOUTH;
                 }
                 break;
             case WEST:
-                if (isSupported(world, tilePos, Side.EAST)){
+                if (isSupported(world, tilePos, Side.EAST)) {
                     rotation = ROTATION_WEST;
                 }
                 break;
             case EAST:
-                if (isSupported(world, tilePos, Side.WEST)){
+                if (isSupported(world, tilePos, Side.WEST)) {
                     rotation = ROTATION_EAST;
                 }
                 break;
         }
 
-        if(rotation == -1) {
+        if (rotation == -1) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         } else {
@@ -127,7 +123,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
@@ -164,7 +160,7 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
             }
         }
 
-        if(rotation == -1) {
+        if (rotation == -1) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         } else {
@@ -173,8 +169,8 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-        if(checkIfAttachedToBlock(world, tilePos)) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (checkIfAttachedToBlock(world, tilePos)) {
             int rotation = getRotation(world.getBlockData(tilePos));
             boolean shouldBreak = switch (rotation) {
                 case ROTATION_EAST -> !isSupported(world, tilePos, Side.WEST);
@@ -185,15 +181,14 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
                 case ROTATION_BOTTOM_NS, ROTATION_BOTTOM_WE -> !isSupported(world, tilePos, Side.TOP);
                 default -> false;
             };
-            if(shouldBreak) {
+            if (shouldBreak) {
                 dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
                 world.setBlockIdNotify(tilePos, 0);
             }
         }
     }
 
-    private boolean checkIfAttachedToBlock(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    private boolean checkIfAttachedToBlock(@NotNull World world, @NotNull TilePosc tilePos) {
         if (canPlaceAt(world, tilePos)) {
             return true;
         } else {
@@ -204,129 +199,133 @@ public class BlockLogicLever extends BlockLogic implements ISupportable
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int rotation = getRotation(source.getBlockData(tilePos));
         final float f = 0.1875F;
         final float f1 = 0.25f;
         return switch (rotation) {
-            case ROTATION_EAST -> AABB.fromPool(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
-            case ROTATION_WEST -> AABB.fromPool(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
-            case ROTATION_SOUTH -> AABB.fromPool(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
-            case ROTATION_NORTH -> AABB.fromPool(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
-            case ROTATION_TOP_NS, ROTATION_TOP_WE -> AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
-            default -> AABB.fromPool(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
+            case ROTATION_EAST -> new AABBd(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+            case ROTATION_WEST -> new AABBd(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+            case ROTATION_SOUTH -> new AABBd(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+            case ROTATION_NORTH -> new AABBd(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+            case ROTATION_TOP_NS, ROTATION_TOP_WE -> new AABBd(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+            default -> new AABBd(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
         };
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
-        if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+        if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
             onInteracted(world, tilePos, player, null, 0.0, 0.0);
         }
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         flip(world, tilePos, player);
         return true;
     }
 
-    public void flip(@NotNull World world, @NotNull TilePos tilePos, @Nullable Player player) {
+    public void flip(@NotNull World world, @NotNull TilePosc tilePos, @Nullable Player player) {
         int meta = world.getBlockData(tilePos);
         int rotation = getRotation(meta);
-        if (isPowered(meta)){
+        if (isPowered(meta)) {
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
         } else {
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
         }
 
         world.markBlocksDirty(tilePos, tilePos);
-        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, isPowered(meta) ? 0.5F : 0.6F);
         world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+
+        TilePos queryPos = new TilePos();
         switch (rotation) {
-            case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(), this.block.id());
-            case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(), this.block.id());
-            case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(), this.block.id());
-            case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(), this.block.id());
-            case ROTATION_TOP_NS, ROTATION_TOP_WE -> world.notifyBlocksOfNeighborChange(tilePos.down(), this.block.id());
-            default -> world.notifyBlocksOfNeighborChange(tilePos.up(), this.block.id());
+            case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block.id());
+            case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block.id());
+            case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block.id());
+            case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block.id());
+            case ROTATION_TOP_NS, ROTATION_TOP_WE ->
+                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block.id());
+            default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block.id());
         }
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         flip(world, tilePos, null);
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
-        if(isPowered(data)) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (isPowered(data)) {
             world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+            TilePos queryPos = new TilePos();
             int rotation = getRotation(data);
             switch (rotation) {
-                case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(), this.block.id());
-                case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(), this.block.id());
-                case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(), this.block.id());
-                case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(), this.block.id());
-                case ROTATION_TOP_NS, ROTATION_TOP_WE -> world.notifyBlocksOfNeighborChange(tilePos.down(), this.block.id());
-                default -> world.notifyBlocksOfNeighborChange(tilePos.up(), this.block.id());
+                case ROTATION_EAST -> world.notifyBlocksOfNeighborChange(tilePos.west(queryPos), this.block.id());
+                case ROTATION_WEST -> world.notifyBlocksOfNeighborChange(tilePos.east(queryPos), this.block.id());
+                case ROTATION_SOUTH -> world.notifyBlocksOfNeighborChange(tilePos.north(queryPos), this.block.id());
+                case ROTATION_NORTH -> world.notifyBlocksOfNeighborChange(tilePos.south(queryPos), this.block.id());
+                case ROTATION_TOP_NS, ROTATION_TOP_WE ->
+                    world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block.id());
+                default -> world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block.id());
             }
         }
         super.onRemoved(world, tilePos, data);
     }
 
-    public static int getRotation(int meta){
+    public static int getRotation(int meta) {
         return meta & MASK_ROTATION;
     }
 
-    public static boolean isPowered(int meta){
+    public static boolean isPowered(int meta) {
         return (meta & MASK_POWERED) != 0;
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return isPowered(source.getBlockData(tilePos));
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
-        if(!isPowered(meta)) {
+        if (!isPowered(meta)) {
             return false;
         }
         int rotation = getRotation(meta);
-        if(rotation == ROTATION_BOTTOM_WE && side == Side.BOTTOM) {
+        if (rotation == ROTATION_BOTTOM_WE && side == Side.BOTTOM) {
             return true;
         }
-        if(rotation == ROTATION_BOTTOM_NS && side == Side.BOTTOM) {
+        if (rotation == ROTATION_BOTTOM_NS && side == Side.BOTTOM) {
             return true;
         }
-        if(rotation == ROTATION_TOP_WE && side == Side.TOP) {
+        if (rotation == ROTATION_TOP_WE && side == Side.TOP) {
             return true;
         }
-        if(rotation == ROTATION_TOP_NS && side == Side.TOP) {
+        if (rotation == ROTATION_TOP_NS && side == Side.TOP) {
             return true;
         }
-        if(rotation == ROTATION_NORTH && side == Side.NORTH) {
+        if (rotation == ROTATION_NORTH && side == Side.NORTH) {
             return true;
         }
-        if(rotation == ROTATION_SOUTH && side == Side.SOUTH) {
+        if (rotation == ROTATION_SOUTH && side == Side.SOUTH) {
             return true;
         }
-        if(rotation == ROTATION_WEST && side == Side.WEST) {
+        if (rotation == ROTATION_WEST && side == Side.WEST) {
             return true;
         }
         return rotation == ROTATION_EAST && side == Side.EAST;
     }
 
     @Override
-    public boolean isSignalSource()
-    {
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE.center();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
index 4fd1941a3..601e58431 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLog.java
@@ -1,37 +1,33 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockLogicLog extends BlockLogicAxisAligned
-{
+public class BlockLogicLog extends BlockLogicAxisAligned {
 
-	public BlockLogicLog(@NotNull Block<?> block) {
-        super(block, Material.wood);
+    public BlockLogicLog(@NotNull Block<?> block) {
+        super(block, Materials.WOOD);
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         byte r = 4;
         int r2 = r + 1;
-        if(world.areBlocksLoaded(tilePos.add(-r2, -r2, -r2), tilePos.add(r2, r2, r2))) {
-            TilePos p = new TilePos(tilePos);
-            for(int xOff = -r; xOff <= r; xOff++) {
-                for(int yOff = -r; yOff <= r; yOff++) {
-                    for(int zOff = -r; zOff <= r; zOff++) {
-                        p.set(tilePos.x + xOff, tilePos.y + yOff, tilePos.z + zOff);
-
-                        Block<?> block = world.getBlock(p);
-                        if(!(block != null && block.getLogic() instanceof BlockLogicLeavesBase))
-                        {
+        if (world.areBlocksLoaded(tilePos.add(-r2, -r2, -r2, new TilePos()), tilePos.add(r2, r2, r2, new TilePos()))) {
+            TilePos queryPos = new TilePos();
+            for (queryPos.x = tilePos.x() - r; queryPos.x <= tilePos.x() + r; queryPos.x++) {
+                for (queryPos.y = tilePos.x() - r; queryPos.y <= tilePos.y() + r; queryPos.y++) {
+                    for (queryPos.z = -tilePos.x() - r; queryPos.z <= tilePos.z() + r; queryPos.z++) {
+                        Block<?> block = world.getBlock(queryPos);
+                        if (!(block != null && block.getLogic() instanceof BlockLogicLeavesBase)) {
                             continue;
                         }
-                        int leavesMeta = world.getBlockData(p);
-                        if(!BlockLogicLeavesBase.isPermanent(leavesMeta))
-                        {
-                            world.setBlockData(p, BlockLogicLeavesBase.setDecaying(leavesMeta, true));
+                        int leavesMeta = world.getBlockData(queryPos);
+                        if (!BlockLogicLeavesBase.isPermanent(leavesMeta)) {
+                            world.setBlockData(queryPos, BlockLogicLeavesBase.setDecaying(leavesMeta, true));
                         }
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index bd7ebad4f..091c26f98 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.PlacementMode;
@@ -12,6 +12,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -19,8 +20,9 @@ import java.util.Random;
 
 public class BlockLogicMatcher extends BlockLogicAxisAligned {
     public final boolean isActive;
+
     public BlockLogicMatcher(@NotNull Block<?> block, boolean isActive) {
-        super(block, Material.stone);
+        super(block, Materials.STONE);
         this.isActive = isActive;
     }
 
@@ -30,12 +32,12 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     @Override
-    public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         updateState(world, tilePos);
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
         Axis axis = mob.getPlacementDirection(side, PlacementMode.FACING).getAxis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
@@ -43,23 +45,23 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
         world.scheduleBlockUpdate(tilePos, id(), tickDelay());
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         super.onPlacedOnSide(world, tilePos, side, xHit, yHit);
         world.scheduleBlockUpdate(tilePos, id(), tickDelay());
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         world.scheduleBlockUpdate(tilePos, id(), tickDelay());
     }
 
-    public void updateState(@NotNull World world, @NotNull TilePos tilePos) {
+    public void updateState(@NotNull World world, @NotNull TilePosc tilePos) {
         Axis a = BlockLogicAxisAligned.metaToAxis(world.getBlockData(tilePos) & BlockLogicAxisAligned.MASK_DIRECTION);
 
         TilePos front = new TilePos(tilePos);
@@ -97,9 +99,8 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
-    {
-        if(!this.isActive) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (!this.isActive) {
             return;
         }
 
@@ -107,22 +108,22 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
         double d = 0.0625;
         for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-            double px = (double) tilePos.x + rand.nextFloat();
-            double py = (double) tilePos.y + rand.nextFloat();
-            double pz = (double) tilePos.z + rand.nextFloat();
+            double px = (double) tilePos.x() + rand.nextFloat();
+            double py = (double) tilePos.y() + rand.nextFloat();
+            double pz = (double) tilePos.z() + rand.nextFloat();
 
-            if (!world.isBlockOpaqueCube(tilePos.add(dir))) {
+            if (!world.isBlockOpaqueCube(tilePos.add(dir, new TilePos()))) {
                 switch (dir) {
-                    case UP -> py = (tilePos.y + 1) + d;
-                    case DOWN -> py = (tilePos.y) - d;
-                    case SOUTH -> pz = (tilePos.z + 1) + d;
-                    case NORTH -> pz = (tilePos.z) - d;
-                    case EAST -> px = (tilePos.x + 1) + d;
-                    case WEST -> px = (tilePos.x) - d;
+                    case UP -> py = (tilePos.y() + 1) + d;
+                    case DOWN -> py = (tilePos.y()) - d;
+                    case SOUTH -> pz = (tilePos.z() + 1) + d;
+                    case NORTH -> pz = (tilePos.z()) - d;
+                    case EAST -> px = (tilePos.x() + 1) + d;
+                    case WEST -> px = (tilePos.x()) - d;
                 }
             }
 
-            if (px < tilePos.x || px > (tilePos.x + 1) || py < 0.0D || py > (tilePos.y + 1) || pz < tilePos.z || pz > (tilePos.z + 1)) {
+            if (px < tilePos.x() || px > (tilePos.x() + 1) || py < 0.0D || py > (tilePos.y() + 1) || pz < tilePos.z() || pz > (tilePos.z() + 1)) {
                 world.spawnParticle("reddust", px, py, pz, 0, 0, 0, brightness);
             }
         }
@@ -134,7 +135,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return this.isActive && (BlockLogicAxisAligned.metaToAxis(source.getBlockData(tilePos)) != side.getAxis());
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
index 0da44a74f..fe5ad1884 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicMesh extends BlockLogicTransparent
@@ -12,7 +12,7 @@ public class BlockLogicMesh extends BlockLogicTransparent
 
     public BlockLogicMesh(@NotNull Block<?> block)
     {
-        super(block, Material.metal);
+        super(block, Materials.METAL);
     }
     
     @Override
@@ -28,7 +28,7 @@ public class BlockLogicMesh extends BlockLogicTransparent
     }
 
     @Override
-    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
     }
 }
